#!/usr/bin/env bats

# File: student_tests.sh
# 
# Create your unit tests suit in this file

@test "Example: check ls runs without errors" {
    run "./dsh" <<EOF                
ls
EOF

    # Assertions
    [ "$status" -eq 0 ]
}

@test "Change directory, then remove directory" {
	run "./dsh" <<EOF
cd dsh-test
cd ..
rm dsh-test
EOF

	[ "$status" -eq 0 ]
}

@test "check echo runs without errors" {
	run "./dsh" << EOF
echo "helloooooo sailor"
EOF
	# Strip all whitespace (spaces, tabs, newlines) from the output
    stripped_output=$(echo "$output" | tr -d '\t\n\r\f\v')

    # Expected output with all whitespace removed for easier matching
    expected_output="helloooooo sailordsh2> dsh2> cmd loop returned 0"

	[ "$stripped_output" = "$expected_output" ]

	[ "$status" -eq 0 ]
}
